if(!isObject(KeypadGui)) exec("./KeypadGui.gui");
function keypadcombo_blinkFail() {
	%this = KeypadGui_Combo;
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.getClassName() !$= "GuiSwatchCtrl") continue;
		%obj.setColor("255 0 0 255");
		cancel(%obj.blinkFail);
		cancel(%obj.blinkFailA);
		cancel(%obj.blinkFailB);
		cancel(%obj.blinkFailC);
		cancel(%obj.blinkFailD);
		%obj.blinkFail = %obj.schedule(100,setColor,"255 255 255 255");
		%obj.blinkFailA = %obj.schedule(200,setColor,"255 0 0 255");
		%obj.blinkFailB = %obj.schedule(300,setColor,"255 255 255 255");
		%obj.blinkFailC = %obj.schedule(400,setColor,"255 0 0 255");
		%obj.blinkFailD = %obj.schedule(500,setColor,"255 255 255 255");
	}
}
function keypad_randomizeComboCode() {
	%this = KeypadGui_Combo;
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.getClassName() !$= "GuiSwatchCtrl") continue;
		for(%j=0;%j<%obj.getCount();%j++) {
			%objText = %obj.getObject(%j);
			if(%objText.getClassName() !$= "GuiMLTextCtrl") continue;
			%objText.setText("<font:Consolas Bold:50><just:center>"@getRandom(0,9));
			break;
		}
	}
}
function keypad_validateComboCode() {
	%this = KeypadGui_Combo;
	KeypadGui.isValidatingCode = 1;
	// Let's get the code.
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.getClassName() !$= "GuiSwatchCtrl") continue;
		for(%j=0;%j<%obj.getCount();%j++) {
			%objText = %obj.getObject(%j);
			if(%objText.getClassName() !$= "GuiMLTextCtrl") continue;
			break;
		}
		%code = %code@StripMLControlChars(%objText.getText());
	}
	// Now let's validate.
	%this = KeypadGui;
	if(strLen(%code) < 4) {
		keypadcombo_blinkFail();
		commandToServer('KeypadIncorrect');
		%this.isValidatingCode = 0;
		return;
	}
	if(sha1(%code) !$= %this.correctCode) {
		keypadcombo_blinkFail();
		commandToServer('KeypadIncorrect');
		%this.isValidatingCode = 0;
		return;
	}
	commandToServer('keypadConfirmCallback',%code,%this.callBack);
	canvas.popDialog(KeypadGui);
	%this.isValidatingCode = 0;
}	
package keypadBinding {
	function GuiMouseEventCtrl::onMouseDown(%this) {
		if(%this.combo $= "up") {
			%text = %this.getGroup().getObject(0);
			if(%text.getClassName() !$= "GuiMLTextCtrl") return;
			%number = StripMLControlChars(%text.getText());
			%number++;
			if(%number > 9) %number = 0;
			%text.setText("<font:Consolas Bold:50><just:center>"@%number);
			return;
		}
		if(%this.combo $= "down") {
			%text = %this.getGroup().getObject(0);
			if(%text.getClassName() !$= "GuiMLTextCtrl") return;
			%number = StripMLControlChars(%text.getText());
			%number--;
			if(%number < 0) %number = 9;
			%text.setText("<font:Consolas Bold:50><just:center>"@%number);
			return;
		}
		if(%this.getName() $= "") return;
		if(!isFunction(%this.getName(),"onMouseDown")) return;
		return Parent::onMouseDown(%this);
	}
	function Canvas::pushDialog(%this,%name) {
		if(KeypadGui.expectOpen == 2) {
			for(%i=0;%i<10;%i++) {
				%cmd = getField(%this.defkeybinds,%i);
				if(%cmd $= "")
					GlobalActionMap.unbind(keyboard,%i);
				else
					GlobalActionMap.bindCmd(keyboard,%i,"",%cmd);
			}
			%cmd = getField(%this.defkeybinds,11);
			if(%cmd $= "")
				GlobalActionMap.unbind(keyboard,"enter");
			else
				GlobalActionMap.bindCmd(keyboard,"enter","",%cmd);

		}
		return Parent::pushDialog(%this,%name);
	}
	function Canvas::popDialog(%this,%name) {
		Parent::popDialog(%this,%name);
		if(KeypadGui.expectOpen == 2) {
			for(%i=0;%i<10;%i++) GlobalActionMap.bindCmd(keyboard,%i,"","performKeypadBinding("@%i@");");
			GlobalActionMap.bindCmd(keyboard,"enter","","keypad_validateCode();");
		}
	}
};
activatePackage(keypadBinding);
function clientCmdRequestKeypadCode(%codeType,%correctCode,%callBack) {
	if($Pref::Client::DisableKeypad) return;
	if(KeypadGui.isAwake()) {
		error("ERROR: requestKeypadCode(\""@%correctCode@"\",\""@%callBack@"\") - The keypad gui is already open.");
		return;
	}
//	if(strLen(%correctCode) != 4) {
//		error("ERROR: requestKeypadCode(\""@%correctCode@"\",\""@%callBack@"\") - You must provide a correct code that is four digits in length.");
//		return 0;
//	}
//	for(%i=0;%i<strLen(%correctCode);%i++) {
//		if(stripos("1234567890",getSubStr(%correctCode,%i,1)) == -1) {
//			error("ERROR:  requestKeypadCode(\""@%correctCode@"\",\""@%callBack@"\") - The code must be comprised of digits.");
//			return 0;
//		}
//	}
	// Commented out all of these lines of code because we'll be receiving the correct code from the
	// server in sha1.
	// Just send this back to confirm the data arrival
	commandToServer('RecieveKeypadConfirm');
	KeypadGui.correctCode = %correctCode;
	KeypadGui.callback = %callBack;
	KeypadGui.expectOpen = 1;
	canvas.pushDialog(KeypadGui);
	switch(%codeType) {
		case 2:
			// Pad
			KeypadGui_Pad.setVisible(1);
			KeypadGui_Combo.setVisible(0);
			KeypadGui_Pad.centerX();
			KeypadGui_Pad.centerY();
		case 3:
			// Combo
			keypad_randomizeComboCode();
			KeypadGui_Pad.setVisible(0);
			KeypadGui_Combo.setVisible(1);
			KeypadGui_Combo.centerX();
			KeypadGui_Combo.centerY();
		default:
			// Pad is default.
			KeypadGui_Pad.setVisible(1);
			KeypadGui_Combo.setVisible(0);
			KeypadGui_Pad.centerX();
			KeypadGui_Pad.centerY();
	}
}
function KeypadGui::onSleep(%this) {
	commandToServer('KeypadClose');
	%this.expectOpen = 0;
	for(%i=0;%i<10;%i++) {
		%cmd = getField(%this.defkeybinds,%i);
		if(%cmd $= "")
			GlobalActionMap.unbind(keyboard,%i);
		else
			GlobalActionMap.bindCmd(keyboard,%i,"",%cmd);
	}
	%cmd = getField(%this.defkeybinds,11);
	if(%cmd $= "")
		GlobalActionMap.unbind(keyboard,"enter");
	else
		GlobalActionMap.bindCmd(keyboard,"enter","",%cmd);
}
function KeypadGui::onWake(%this) {
	if(!$Pref::Client::Keypad::DisableNotification && !%this.expectOpen) {
		%e = "WARNING\n\nSomething went wrong. This GUI was opened incorrectly.";
		messageBoxOk("Keypad",%e);
	}
	%this.expectOpen = 2;
	%this.isValidatingCode = 0;
	%display = Keypad_Display;
	%display.setText("<font:Consolas:30>- - - -");
	%this.currentCode = "";
	%this.getObject(0).centerX();
	%this.getObject(0).centerY();
	for(%i=0;%i<10;%i++) %this.defkeybinds = %this.defkeybinds TAB GlobalActionMap.getCommand(keyboard,%i);
	for(%i=0;%i<10;%i++) GlobalActionMap.bindCmd(keyboard,%i,"","performKeypadBinding("@%i@");");
	%this.defkeybinds = %this.defkeybinds TAB GlobalActionMap.getCommand(keyboard,"enter");
	GlobalActionMap.bindCmd(keyboard,"enter","","keypad_validateCode();");
}
function performKeypadBinding(%number) {
	if(canvas.getObject(canvas.getCount()-1) != KeypadGui.getID()) {
		%cmd = getField(KeypadGui.defkeybinds,%number);
		if(%cmd !$= "")
			eval(%cmd);

		return;
	}
	keypad_enterDigit(%number);
}
function keypad_enterDigit(%digit) {
	%this = KeypadGui;
	if(%this.isValidatingCode) return;
	%display = Keypad_Display;
	if(strLen(%this.currentCode) >= 4) return;
	if(strLen(%this.currentCode) == 0)
		%displayTxt = "<font:Consolas:30>"@%digit@" - - -";
	else
		%displayTxt = setWord(%display.getText(),strLen(%this.currentCode),%digit);

	%display.setText(%displayTxt);
	%this.currentCode = %this.currentCode @ %digit;
}
function keypad_clearCode() {
	%this = KeypadGui;
	if(%this.isValidatingCode) return;
	%display = Keypad_Display;
	%display.setText("<font:Consolas:30>- - - -");
	%this.currentCode = "";
}
function keypad_validateCode() {
	%this = KeypadGui;
	%display = Keypad_Display;
	%this.isValidatingCode = 1;
	if(strLen(%this.currentCode) < 4) {
		%this.blinkFail("ERR");
		commandToServer('KeypadIncorrect');
		return;
	}
	if(sha1(%this.currentCode) !$= %this.correctCode) {
		%this.blinkFail("ERR");
		commandToServer('KeypadIncorrect');
		return;
	}
	commandToServer('keypadConfirmCallback',%this.currentCode,%this.callBack);
	%this.blinkSuccess();
	%this.isValidatingCode = 0;
}
function KeypadGui::blinkFail(%this,%msg) {
	%msg = strUpr(%msg);
	%display = Keypad_Display;
	%ONE = getSubStr(%msg,0,1);
	%TWO = getSubStr(%msg,1,1);
	%THR = getSubStr(%msg,2,1);
	%FOU = getSubStr(%msg,3,1);
	%display.setText("<font:Consolas:30><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU);
	%display.schedule(100,setText,"<font:Consolas:30><color:ff0000>");
	%display.schedule(200,setText,"<font:Consolas:30><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU);
	%display.schedule(300,setText,"<font:Consolas:30><color:ff0000>");
	%display.schedule(400,setText,"<font:Consolas:30><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU);
	%display.schedule(450,setText,"<font:Consolas:30><color:ff0000>- "@%TWO SPC %THR SPC %FOU);
	%display.schedule(500,setText,"<font:Consolas:30><color:ff0000>- - "@%THR SPC %FOU);
	%display.schedule(550,setText,"<font:Consolas:30><color:ff0000>- - - "@%FOU);
	%display.schedule(600,setText,"<font:Consolas:30><color:ff0000>- - - -");
	%display.schedule(650,setText,"<font:Consolas:30><color:000000>-<color:ff0000> - - -");
	%display.schedule(700,setText,"<font:Consolas:30><color:000000>- -<color:ff0000> - -");
	%display.schedule(750,setText,"<font:Consolas:30><color:000000>- - -<color:ff0000> -");
	%display.schedule(800,setText,"<font:Consolas:30><color:000000>- - - -");
	%this.schedule(850,setField,currentCode,"");
	%this.schedule(850,setField,isValidatingCode,0);
}
function KeypadGui::blinkSuccess(%this) {
	%display = Keypad_Display;
	%this.currentCode = "";
	%this.isValidatingCode = 0;
	canvas.popDialog(KeypadGui);
	return;
	// We don't want to keep the client waiting.
	%display.setText("<font:Consolas:30><color:00ff00>Y E S");
	%display.schedule(100,setText,"<font:Consolas:30><color:00ff00>");
	%display.schedule(200,setText,"<font:Consolas:30><color:00ff00>Y E S");
	%display.schedule(300,setText,"<font:Consolas:30><color:00ff00>");
	%display.schedule(400,setText,"<font:Consolas:30><color:00ff00>Y E S");
	%display.schedule(450,setText,"<font:Consolas:30><color:00ff00>- E S");
	%display.schedule(500,setText,"<font:Consolas:30><color:00ff00>- - S");
	%display.schedule(550,setText,"<font:Consolas:30><color:00ff00>- - -");
	%display.schedule(600,setText,"<font:Consolas:30><color:00ff00>- - - -");
	%display.schedule(650,setText,"<font:Consolas:30><color:000000>-<color:00ff00> - - -");
	%display.schedule(700,setText,"<font:Consolas:30><color:000000>- -<color:00ff00> - -");
	%display.schedule(750,setText,"<font:Consolas:30><color:000000>- - -<color:00ff00> -");
	%display.schedule(800,setText,"<font:Consolas:30><color:000000>- - - -");
	%this.schedule(850,setField,currentCode,"");
	%this.schedule(850,setField,isValidatingCode,0);
	canvas.schedule(900,popDialog,KeypadGui);
}