package NewKeypadEncryptPackage {
	function SimObject::serializeEvent(%obj,%idx) {
		%line = Parent::serializeEvent(%obj,%idx);
		if(outputEvent_getOutputName("fxDTSBrick",getField(%line,5)) $= "sendKeypadRequest") {
			%line = setField(%line,7,"0000");
		}
		return %line;
	}
	function serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4) {
		if(!isObject(%brick = %client.wrenchBrick)) return;
		%currentEvent = (%brick.numEvents $= "" ? "0" : %brick.numEvents);
		if(outputEvent_getOutputName("fxDTSBrick",%outputEventIdx) $= "sendKeypadRequest") {
			if(!%brick.hasBeenKeypadChecked) {
				%brick.hasBeenKeypadChecked = 1;
				if(strLen(%par2) == 4) {
					// Backwards compatibility
					%brick.newKeypad_realPassword = %par2;
					%brick.newKeypad_Password = sha1(%par2);
				} else {
					%brick.newKeypad_Password = %Par2;
					%brick.newKeypad_realPassword = "0000";
				}
				Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, "0000", %par3, %par4);
				%brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
				return;
			}
			if(%par2 $= "0000") { // Make sure that they don't have to set the code everytime they save events
				if(%brick.newKeypad_Password !$= "") {
					Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, "0000", %par3, %par4);
					%brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
					return;
				}
			}
			if((strLen(%par2) != 4 || stripChars(%par2,"0123456789") !$= "") && ((%brick.newKeypad_lastType !$= "" && %brick.newKeypad_lastType $= %par1) || %brick.newKeypad_lastType $= "")) {
				if(%brick.newKeypad_realPassword !$= "") {
					messageClient(%client, '', "\c0You did not provide a valid code, so your keypad code will remain the same.");
					Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %brick.newKeypad_realPassword, %par3, %par4);
					if(%brick.newKeypad_Password !$= "") %brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
					return;
				} else {
					messageClient(%client, '', "\c0You did not provide a valid code, so your keypad code will remain unset.");
					Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, "0000", %par3, %par4);
					if(%brick.newKeypad_Password !$= "") %brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
					return;
				}
			}
			if(sha1(%par2) $= %brick.newKeypad_Password || %par2 $= %brick.newKeypad_realPassword) {
				commandToClient(%client, 'messageBoxOk', "New Keypad Events", "You don't have to set your keypad code everytime you save events.");
				Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, "0000", %par3, %par4);
				if(%brick.newKeypad_Password !$= "") %brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
				return;
			}
			%brick.newKeypad_Password = sha1(%par2);
			%brick.newKeypad_realPassword = %par2;
			%brick.newKeypad_lastType = %par1;
			messageClient(%client, '', "\c2Your code has been set!");
			%par2 = "0000";
			Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4);
			%brick.eventOutputParameter[%currentEvent@"_2"] = %brick.newKeypad_Password;
			return;
		}
		Parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4);
	}
};
activatePackage(NewKeypadEncryptPackage);
exec("./events.cs");
function GameConnection::sendKeypadRequest(%this,%codeType,%code,%callback) {
	if(!isObject(%this)) {
		error("ERROR: "@%this@"::sendKeypadRequest(\""@%code@"\",\""@%callBack@"\") - Client object does not exist.");
		return;
	}
	if(!isFunction("serverCmd"@%callBack)) {
		if(!isObject(%callBack)) {
			error("ERROR: "@%this@"::sendKeypadRequest(\""@%code@"\",\""@%callBack@"\") - Callback function does not exist.");
			return;
		} else if(%callBack.getClassName() !$= "fxDTSBrick") {
			error("ERROR: "@%this@"::sendKeypadRequest(\""@%code@"\",\""@%callBack@"\") - Callback function does not exist.");
			return;
		}
	}
	%this.hasKeypadAddon = 0;
	%this.callBack = %callBack;
	%this.code = %code;
	commandToClient(%this,'requestKeypadCode',%codeType,%code,%callback);
	cancel(%this.keypadTimeout);
	%this.keypadTimeout = schedule(100,0,keypad_timeoutClient,%this);
}
function serverCmdKeypadIncorrect(%cl) {
	if(isObject(%cl.callBack)) if(%cl.callBack.getClassName() $= "fxDTSBrick") %cl.callBack.onKeypadIncorrect(%cl);
}
function serverCmdRecieveKeypadConfirm(%cl) {
	// If this function is called after we sent a keypad request, then we can confirm that the client
	// got the data & parsed it correctly. (aka they have the addon)
	%cl.hasKeypadAddon = 1;
	cancel(%cl.keypadTimeout);
}
function serverCmdKeypadClose(%cl) {
	if(isObject(%cl.callBack)) if(%cl.callBack.getClassName() $= "fxDTSBrick") %cl.callBack.onKeypadCancel(%cl);
	%cl.hasKeypadAddon = 0;
	%cl.callBack = "";
	%cl.code = "";
}
function serverCmdKeypadConfirmCallback(%cl,%code,%callBack) {
	if(sha1(%cl.callBack) !$= sha1(%callBack)) {
		if($DebugKeypad) error("ERROR: serverCmdKeypadConfirmCallback("@%cl@","@%code@","@%callBack@") - Client sent back incorrect callback.");
		if(!%cl.hasKeypadAddon) messageClient(%cl,'',"\c6Incorrect code, try again.");
		return;
	}
	if(%cl.code !$= sha1(%code)) {
		if($DebugKeypad) error("ERROR: serverCmdKeypadConfirmCallback("@%cl@","@%code@","@%callBack@") - Client sent back incorrect keypad code.");
		if(!%cl.hasKeypadAddon) messageClient(%cl,'',"\c6Incorrect code, try again.");
		return;
	}
	%cl.callBack = "";
	%cl.code = "";
	if(!isFunction("serverCmd"@%callBack)) {
		if(!isObject(%callBack)) {
			error("ERROR: serverCmdKeypadConfirmCallback("@%cl@","@%code@","@%callBack@") - Callback function does not exist.");
			return;
		} else if(%callBack.getClassName() !$= "fxDTSBrick") {
			error("ERROR: serverCmdKeypadConfirmCallback("@%cl@","@%code@","@%callBack@") - Callback function does not exist.");
			return;
		}
		if(!%cl.hasKeypadAddon) messageClient(%cl,'',"\c6Success!");
		%callBack.onKeypadCorrect(%cl);
	} else {
		if(!%cl.hasKeypadAddon) messageClient(%cl,'',"\c6Success!");
		eval("serverCmd"@%callBack@"("@%cl@");");
	}
	if(%cl.allowKeypadServerCmd) {
		%cl.allowKeypadServerCmd = 0;
		clearCenterPrint(%cl);
		%cl.keypad_currentCode = "";
		%cl.keypad_pos = "0 0";
	}
}
function kpRegisterPrefs() {
	echo("(SUPPORT) Keypad > Blockland Glass : Registering prefs");
	RTB_registerPref("Allow onKeypadCancel","Keypad | Limitations","$Pref::Server::Keypad::AllowonKeypadCancel","bool","Script_NewKeypad",false,false,false,"");
	RTB_registerPref("Restrict long-range code entering","Keypad | Limitaions","$Pref::Server::Keypad::closeKeypadIfWalkAway","bool","Script_NewKeypad",true,false,false,"");
}
kpRegisterPrefs();
package KeypadSupport_BrickCtrl {
	function serverCmdCancelBrick(%client) {
		if(!%client.allowKeypadServerCMD) return Parent::serverCmdCancelBrick(%client);
		keypad_selectNumber(%client,"X");
	}
	function serverCmdPlantBrick(%client) {
		if(!%client.allowKeypadServerCMD) return Parent::serverCmdPlantBrick(%client);
		keypad_selectNumber(%client,%client.keypad_selecteditem);
	}
	function serverCmdShiftBrick(%client, %x, %y, %z) {
		if(!%client.allowKeypadServerCMD) Parent::serverCmdShiftBrick(%client, %x, %y, %z);
		if(keypad_calculateTooFarDistance(%client)) return;
		if(%x != 0) {
			// Up and down
			%client.keypad_pos = setWord(%client.keypad_pos,1,getWord(%client.Keypad_pos,1)-%x);
		}
		if(%y != 0) {
			// Left or right
			%client.keypad_pos = setWord(%client.keypad_pos,0,getWord(%client.Keypad_pos,0)-%y);
		}
		keypad_updateCenterPrint(%client);
	}
	function serverCmdSuperShiftBrick(%client, %x, %y, %z) {
		if(!%client.allowKeypadServerCMD) return Parent::serverCmdSuperShiftBrick(%client, %x, %y, %z);
		if(%x != 0) {
			// Up and down
			%client.keypad_pos = setWord(%client.keypad_pos,1,getWord(%client.Keypad_pos,1)-%x);
		}
		if(%y != 0) {
			// Left or right
			%client.keypad_pos = setWord(%client.keypad_pos,0,getWord(%client.Keypad_pos,0)-%y);
		}
		keypad_updateCenterPrint(%client);
	}
};
activatePackage(KeypadSupport_BrickCtrl);
function serverCmdKeypadNone_Cancel(%cl) {
	if(%cl.keypad_doingFailBlink) return;
	if(isObject(%cl.callBack)) if(%cl.callBack.getClassName() $= "fxDTSBrick") %cl.callBack.onKeypadCancel(%cl);
	%cl.allowKeypadServerCmd = 0;
	%cl.code = "";
	%cl.keypad_currentcode = "";
	%cl.keypad_selection = 0;
	clearCenterPrint(%cl);
}
function keypad_calculateTooFarDistance(%cl) {
	// -1 : Error
	//  0 : Close enough
	//  1 : Too far away
	if(!$Pref::Server::Keypad::closeKeypadIfWalkAway) return 0;
	if(!isObject(%cl.getControlObject())) return 1;
	if(!isObject(%cl.callBack)) return -1;
	if(%cl.callBack.getClassName() !$= "fxDTSBrick") return -1;
	%brick = %cl.callBack;
	if(vectorDist(%brick.getPosition(),%cl.getControlObject().getPosition()) > 5) {
		// The player is too far away to enter a code.
		messageClient(%cl,'',"\c6You are too far away from the keypad brick.");
		%cl.hasKeypadAddon = 0;
		%cl.callBack = "";
		%cl.allowKeypadServerCMD = 1;
		%cl.code = "";
		%cl.keypad_currentcode = "";
		%cl.keypad_selection = 0;
		clearCenterPrint(%cl);
		serverCmdKeypadNone_Cancel(%cl);
		return 1;
	}
	return 0;
}
function keypad_selectNumber(%cl,%digit) {
	if(!%cl.allowKeypadServerCMD) return;
	if(%cl.keypad_doingFailBlink) return;
	switch$(%digit) {
		case "X":
			if(%cl.keypad_currentCode $= "") {
				// Maybe the client wants to stop using the keypad
				commandToClient(%cl,'MessageBoxYesNo',"Keypad","Are you sure you wish to stop entering a code?",'KeypadNone_Cancel');
				return;
			}
			%cl.keypad_currentCode = "";
		case ">":
			echo(sha1(%cl.keypad_currentCode));
			echo(%cl.code);
			if(sha1(%cl.keypad_currentCode) !$= %cl.code) {
				messageClient(%cl,'',"\c6Incorrect code, try again.");
				keypad_blinkFail(%cl,"ERR");
				serverCmdKeypadIncorrect(%cl);
				%cl.keypad_currentCode = "";
			} else
				serverCmdKeypadConfirmCallback(%cl,%cl.keypad_currentCode,%cl.callBack);
		default:
			if(strLen(%cl.keypad_currentCode) == 4) return;
			%cl.keypad_currentCode = %cl.keypad_currentCode @ %digit;
	}
	keypad_updateCenterPrint(%cl);
}
function keypad_blinkFail(%cl,%msg) {
	if(!%cl.allowKeypadServerCmd) return;
	if(%cl.keypad_doingFailBlink) return;
	%cl.keypad_doingFailBlink = 1;
	%ONE = getSubStr(%msg,0,1);
	%TWO = getSubStr(%msg,1,1);
	%THR = getSubStr(%msg,2,1);
	%FOU = getSubStr(%msg,3,1);
	if(%ONE $= "") %ONE = " ";
	if(%TWO $= "") %TWO = " ";
	if(%THR $= "") %THR = " ";
	if(%FOU $= "") %FOU = " ";
	centerPrint(%cl,"<font:Consolas:20><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(100,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>" NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(200,0,centerPrint,%cl,"<font:Consolas:20><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(300,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>" NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(400,0,centerPrint,%cl,"<font:Consolas:20><color:ff0000>"@%ONE SPC %TWO SPC %THR SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(500,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>" NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(600,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>-<color:ff0000>" SPC %TWO SPC %THR SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(650,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>- -<color:ff0000>" SPC %THR SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(700,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>- - -<color:ff0000>" SPC %FOU NL "" NL "<color:ffffff>1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	schedule(750,0,centerPrint,%cl,"<font:Consolas:20><color:ffffff>- - - -" NL "" NL "1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >");
	%cl.schedule(800,setField,keypad_doingFailBlink,0);
	schedule(850,0,keypad_updateCenterPrint,%cl);
}
function keypad_updateCenterPrint(%cl) {
	if(%cl.keypad_doingFailBlink) return;
	if(!%cl.allowKeypadServerCMD) {
		clearCenterPrint(%cl);
		return;
	}
	if(keypad_calculateTooFarDistance(%cl)) return;
	%btns = "1 2 3" NL "4 5 6" NL "7 8 9" NL "X 0 >";
	if(getWord(%cl.keypad_pos,0) > 2) %cl.keypad_pos = "0" SPC getWord(%cl.keypad_pos,1);
	if(getWord(%cl.keypad_pos,0) < 0) %cl.keypad_pos = strLen(getRecord(strReplace(%btns," ",""),0))-1 SPC getWord(%cl.keypad_pos,1);
	if(getWord(%cl.keypad_pos,1) > getRecordCount(%btns)-1) %cl.keypad_pos = getWord(%cl.keypad_pos,0) SPC "0";
	if(getWord(%cl.keypad_pos,1) < 0) %cl.keypad_pos = getWord(%cl.keypad_pos,0) SPC getRecordCount(%btns)-1;
	%sel = %cl.keypad_pos;
	%posSel = getRecord(%btns,getWord(%sel,1));
	%tempChar = getWord(%posSel,getWord(%sel,0));
	%posSel = setWord(%posSel,getWord(%sel,0),"<spush><color:00ff00><font:Consolas Bold:20>"@%tempChar@"<spop>");
	%cl.keypad_selecteditem = %tempChar;
	%btns = setRecord(%btns,getWord(%sel,1),%posSel);
	%codeDisp = "- - - -";
	for(%i=0;%i<strLen(%cl.keypad_currentCode);%i++) {
		%digit = getSubStr(%cl.keypad_currentCode,%i,1);
		%codeDisp = setWord(%codeDisp,%i,%digit);
	}
	%format = "<font:Consolas:20><color:ffffff>"@%codeDisp NL "" NL %btns;
	centerPrint(%cl,%format);
}
function keypad_timeoutClient(%cl) {
	// Make some extra support here for people without the keypad addon.
	%cl.allowKeypadServerCMD = 1;
	%cl.keypad_pos = "0 0";
	%cl.keypad_doingFailBlink = 0;
	%cl.keypad_currentCode = "";
	if(!%cl.keypad_initialMessage) {
		messageClient(%cl,'',"\c6This brick requires a passcode. Since you do not have the <a:https://blocklandglass.com/addons/addon.php?id=425>New Keypad</a>\c6 add-on, you will have to use the subsitution. Control scheme:");
		messageClient(%cl,'',"\c6Brick Left / Up / Right / Down - \c4Navigate left / up / right / down.");
		messageClient(%cl,'',"\c6Place brick - \c4Select the currently highlighted buttons.");
		messageClient(%cl,'',"\c6Cancel brick - \c4Clear the code you currently have. If you press this when there is no code entered, you will be asked if you want to stop typing in a code.");
		messageClient(%cl,'',"\c6Brick Left / Up / Right / Down - \c4Navigate left / up / right / down.");
		messageClient(%cl,'',"\c2Alternative: \c5/entercode [code]");
		messageClient(%cl,'',"\c6This message will not show up again until you rejoin.");
		%cl.keypad_initialMessage = 1;
	}
	keypad_updateCenterPrint(%cl);
}
function serverCmdEnterCode(%cl,%code) {
	if(!%cl.allowKeypadServerCMD) return;
	if(keypad_calculateTooFarDistance(%cl)) {
		%cl.allowKeypadServerCMD = 0;
		return;
	}
	if(sha1(%code) !$= %cl.code) {
		serverCmdKeypadIncorrect(%cl);
		messageClient(%cl,'',"\c6Incorrect, try again.");
		return;
	}
	%cl.allowKeypadServerCMD = 0;
	clearCenterPrint(%cl);
	serverCmdKeypadConfirmCallback(%cl,%code,%cl.callback);
}